=== debian/changelog ===
vimix (0.9.0+ds-2) unstable; urgency=medium

  * d/control: actually add libgstreamer-plugins-bad1.0-dev.

 -- Alex Myczko <tar@debian.org>  Wed, 18 Feb 2026 08:24:58 +0000

vimix (0.9.0+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.
  * d/watch: bump to version 5.
  * d/control:
    - add libgstreamer-plugins-bad1.0-dev to build-depends.
    - drop Rules-Requires-Root.
  * d/patches: dropped.
  * Bump standards version to 4.7.3.

 -- Alex Myczko <tar@debian.org>  Wed, 18 Feb 2026 06:47:32 +0000
