=== debian/watch ===
Version: 5

# GitHub hosted projects
Template: Github
Owner: brunoherbelin
Project: vimix
Update-Script: uupdate
