## vimix 0.9.0+git20260228+ds

=== debian/changelog ===
vimix (0.9.0+git20260228+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Wed, 18 Feb 2026 08:24:58 +0000
